;;===========================================================================
;OM API 
;Multiplatform API for OpenMusic
;Macintosh version (Digitool Macintosh Common Lisp - MCL)
;
;Copyright (C) 2004 IRCAM-Centre Georges Pompidou, Paris, France.
; 
;This program is free software; you can redistribute it and/or
;modify it under the terms of the GNU General Public License
;as published by the Free Software Foundation; either version 2
;of the License, or (at your option) any later version.
;
;See file LICENSE for further informations on licensing terms.
;
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License for more details.
;
;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
;
;Authors: Jean Bresson and Augusto Agon
;;===========================================================================

;;===========================================================================
;DocFile
; OM OpenGL  (use OpenGL for MCL)
;;===========================================================================

(in-package :oa)


(export '(
              om-opengl-view
              om-opengl-window
              
              om-with-rgba-vector
              
              om-gl-set-current-context
              om-gl-display
              
              ) :om-api)



(defclass om-opengl-view (ccl::OPENGL-VIEW om-view) ())


(defclass om-opengl-window (ccl::OPENGL-Window om-abstract-window)
   ())



(defmethod om-gl-set-current-context ((view om-opengl-view))
  (aglSetCurrentContext (aglcontext Self))
  (agl-error-check)
  ;;;(glviewport x y Width Height)
  (unless (aglUpdateContext (aglcontext Self))
    (error "OpenGL could not adjust viewport to new size"))
   )


#|
(defmethod cg::resize-window :after ((window om-gl-stream) size)
   (declare (ignore size))
   (fit-size window)
   (cg::invalidate window))

(defun fit-size (window)
   ;; Always call this before calling OpenGL functions that are
   ;; intended for a particular CG stream.
   (setf (cggl::current-cggl-stream) window)
   ;; This is a common OpenGL function set the size of the drawing.
   (gl::glViewport 0 0 (cg::interior-width window)(cg::interior-height window)))

|#

(defmethod display ((window om-opengl-view))
  (call-next-method)
  (om-gl-display window))

(defmethod display ((window om-opengl-window))
  (call-next-method)
  (om-gl-display window))



(defmethod om-gl-display ((window om-opengl-view)) 
   (gl::glClear gl::GL_COLOR_BUFFER_BIT)
   (gl::glBegin gl::GL_TRIANGLES)
   (gl::glColor3f 1.0 0.0 0.0)
   (gl::glVertex2i 0 1)
   (gl::glColor3f 0.0 1.0 0.0)
   (gl::glVertex2i -1 -1)
   (gl::glColor3f 0.0 0.0 1.0)
   (gl::glVertex2i 1 -1)
   (gl::glEnd)
   )


(defun floatvec (&rest args)
   (make-array (length args) 
                      :element-type 'single-float
                      :initial-contents args))


(defmacro om-WITH-RGBA-VECTOR (Vector (red green blue alpha) &body Forms)
   `(ccl::with-rgba-vector ,Vector (,red ,green ,blue ,alpha)
      ,@Forms))


#|
(defmethod om-VIEW-CLICK-HANDLER ((Self om-opengl-view) Where)
   (declare (ignore Where))
   (call-next-method)
   (setf (cggl::current-cggl-stream) (cg::window self))
   ;;;  (track-mouse-3d (camera Self))
   )
|#
   
;;;(defmethod VIEW-KEY-EVENT-HANDLER ((Self opengl-simple-view) Char)
;;;  (declare (ignore Char))
;;;  (ed-beep))






;;____________________
;; Text functions     |
;;____________________/
;;;
;;;(defmethod MAKE-OPENGL-FONT ((Self opengl-simple-view) &optional (Font-Id $geneva) (Font-Size 24) (Font-Style 0))
;;;  ;; make an OpenGL font and make it the current font
;;;  (let ((Font (glgenlists 96)))
;;;    (aglUseFont (aglcontext Self) 
;;;                Font-Id 
;;;                Font-Style   ;; bitset: {bold, italic, underline, outline, shadow, condense, extend}
;;;                Font-Size  
;;;                32  ;; starting at the space
;;;                96  ;; number of characters in set
;;;                Font)
;;;    (agl-error-check)
;;;    (setf (font Self) Font)
;;;    Font))
;;;
;;;
;;;(defmethod GLPRINT ((Self opengl-simple-view) String &optional Font)
;;;  (let ((Font (or Font (current-font Self) (make-opengl-font Self))))
;;;    (glPushAttrib gl_list_bit)
;;;    (glListBase (- Font 32))
;;;    (with-cstr (&String String)
;;;      (glCallLists (length String) gl_unsigned_byte &String))
;;;    (glPopAttrib)))

