;;===========================================================================
;OM API 
;Multiplatform API for OpenMusic
;Macintosh version (Digitool Macintosh Common Lisp - MCL)
;
;Macintosh version (Digitool Macintosh Common Lisp - MCL)
;
;Copyright (C) 2004 IRCAM-Centre Georges Pompidou, Paris, France.
; 
;This program is free software; you can redistribute it and/or
;modify it under the terms of the GNU General Public License
;as published by the Free Software Foundation; either version 2
;of the License, or (at your option) any later version.
;
;See file LICENSE for further informations on licensing terms.
;
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License for more details.
;
;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
;
;Authors: Augusto Agon and Jean Bresson
;;===========================================================================

;;===========================================================================
;DocFile
; TOOLTIPS (use Alexander Repenning Help Tag Manager)
;;===========================================================================



(in-package :om-api)


;==========
; export :
;==========
(export '(
                om-set-help
                om-help-on?
                om-show-tooltip
                om-hide-tooltip
                ) :om-api)

;======================
(in-package :oa)


(defvar *helpon* nil)

(defun om-set-help (mode)
  (setf *helpon* mode))

(defun om-help-on? ()  
  *helpon*)

(defmethod om-view-set-help ((self om-graphic-object) (text string))
  "a faire")


(defmethod om-show-tooltip ((self om-graphic-object) &optional (remove nil)) t)

(defmethod om-show-tooltip ((self om-view) &optional (remove nil))  
  (capi:display-tooltip self  :x 0  :y -20 :text (help-spec self)))

(defmethod om-hide-tooltip ((self om-graphic-object)) t)

(defmethod om-hide-tooltip ((self om-view)) 
  (capi:display-tooltip self))

(defun init-tooltips ()
  (om-set-help t))

(om-add-init-func 'init-tooltips) 




