;OpenMusic
;
;Copyright (C) 1997, 1998, 1999, 2000 by IRCAM-Centre Georges Pompidou, Paris, France.
; 
;This program is free software; you can redistribute it and/or
;modify it under the terms of the GNU General Public License
;as published by the Free Software Foundation; either version 2
;of the License, or (at your option) any later version.
;
;See file LICENSE for further informations on licensing terms.
;
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License for more details.
;
;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
;
;Authors: Gerard Assayag and Augusto Agon


;DocFile
;This file define the *kernel-files* global variable, which contains a list
;with the basic file's pathnames.
;Last Modifications :
;18/10/97 first date.
;DocFile
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(in-package :om)
 
(defvar *kernel-files* nil)

(setf *kernel-files* '(
                       
;-----------Tools--------------------------------- 
"code:kernel;tools;lisptools"    
"code:kernel;tools;saveheader"   
"code:kernel;graphics;graphictools" 

;--------------Scheduler----------------- 
"code:kernel;tools;scheduler"   
                                    
;-----------Containers---------------------------- 
"code:kernel;classes;container"   

;-----------Modele-------------------------------- 
"code:kernel;ommodele;genfunmetaclass"                                     
"code:kernel;ommodele;metaclasses"   
"code:kernel;ommodele;defgeneric"      
"code:kernel;ommodele;protocol"
"code:kernel;ommodele;modele"             
                                    
;-----------Graphics------------------------------ 
"code:kernel;graphics;icons;iconview" 
"code:kernel;graphics;icons;picture"     
"code:kernel;graphics;dialogs" 
"code:kernel;graphics;rulers"  

;-----------Basic Objects------------------------- 
"code:kernel;ommodele;ombasicobjects;ombasictype"  
"code:kernel;ommodele;ombasicobjects;omlispfun"      
"code:kernel;ommodele;ombasicobjects;ominstance"      
"code:kernel;ommodele;ombasicobjects;omclass"           
"code:kernel;ommodele;ombasicobjects;omslot"              
"code:kernel;ommodele;ombasicobjects;omgenfun"      
"code:kernel;ommodele;ombasicobjects;ommethod"                                      
"code:kernel;ommodele;ombasicobjects;ompatch"          
"code:kernel;ommodele;ombasicobjects;ommaquette"   
"code:kernel;ommodele;ombasicobjects;omfolder"         
"code:kernel;ommodele;ombasicobjects;omworkspace" 
"code:kernel;ommodele;ombasicobjects;boxes;ombox"  
"code:kernel;ommodele;ombasicobjects;boxes;patchboxes" 
"code:kernel;ommodele;ombasicobjects;boxes;temporalboxes" 
"code:kernel;ommodele;ombasicobjects;boxes;classtreeboxes"  
"code:kernel;ommodele;ombasicobjects;ompackage"   
"code:kernel;ommodele;ombasicobjects;omlib" 
                       
                       
;----------- Editor Frames------------------------------- 

;editor
"code:kernel;ommodele;omframes;containereditors;editorwindow"   
                                    
;containers
"code:kernel;ommodele;omframes;containereditors;metaobjectcontainer" 

"code:kernel;ommodele;omframes;containereditors;nonrelationcontainer"  
"code:kernel;ommodele;omframes;containereditors;browsercontainer"  
"code:kernel;ommodele;omframes;containereditors;relationcontainer"  
"code:kernel;ommodele;omframes;containereditors;hierarchiecontainer"  
"code:kernel;ommodele;omframes;containereditors;instancecontainer"


"code:kernel;ommodele;omframes;containereditors;algortimecontainer;patchcontainer"
"code:kernel;ommodele;omframes;containereditors;algortimecontainer;methodcontainer"
"code:kernel;ommodele;omframes;containereditors;algortimecontainer;setgetslotscontainer"
"code:kernel;ommodele;omframes;containereditors;algortimecontainer;maquettecontainer"


;----------- Simple Frames------------------------------- 
"code:kernel;ommodele;omframes;simpleframes;iconsframe;iconfinder"     
"code:kernel;ommodele;omframes;simpleframes;iconsframe;basicobjectsframes" 
"code:kernel;ommodele;omframes;simpleframes;iconsframe;methodframe" 
"code:kernel;ommodele;omframes;simpleframes;boxes;inlet" 
"code:kernel;ommodele;omframes;simpleframes;boxes;controls" 
"code:kernel;ommodele;omframes;simpleframes;boxes;boxframe"  
"code:kernel;ommodele;omframes;simpleframes;boxes;in-out-boxes"
"code:kernel;ommodele;omframes;simpleframes;boxes;connections"
"code:kernel;ommodele;omframes;simpleframes;boxes;maquetteframe"
"code:kernel;ommodele;omframes;simpleframes;boxes;maq-in-out"
"code:kernel;ommodele;omframes;simpleframes;boxes;miniviews"


;-----------Aux windows------------------------------ 
"code:kernel;graphics;infowindow"
"code:kernel;graphics;palette"

;-----------Controls------------------------------- 
"code:kernel;boxes;boxeswitheditor;boxwithpatch"
"code:kernel;boxes;boxeswitheditor;omloop"
"code:kernel;boxes;basicboxes"
"code:kernel;boxes;boxeswitheditor;ompatch"
"code:kernel;classes;picture"

;--------------------Print---------------------- ???
"code:kernel;graphics;print"     ; XXX

;--------------------Player---------------------- 
"code:kernel;tools;player"

;-------------Preferences----------------------- 
"code:kernel;graphics;preferences"


;-----------Persistant&copy--------------------- 
"code:kernel;ommodele;persistant;copy"  
"code:kernel;ommodele;persistant;save"
"code:kernel;ommodele;persistant;import-export"   ; my-copy-file..
                                                                    
;-----------Menu----------------------------------- 
"code:kernel;graphics;ommenu"


;--------------OM-Drag-and-Drop----------------- 
"code:kernel;graphics;dragdrop;omdraganddrop"
"code:kernel;graphics;dragdrop;dropallowp"    
"code:kernel;graphics;dragdrop;performdrop"

;--------------Help----------------- 
"code:kernel;tools;onlinepatches"


))