(in-package :om)


;;;=====================================
;;; OBjet Sheet Persistant


(defmethod omNG-make-new-persistant ((type (eql 'sh)) frame pos) 
  (omNG-make-new-sheet (mk-unique-name frame "Sheet") pos))

(defun omNG-make-new-sheet (name &optional (posi (om-make-point 0 0)))
   "Make an instance of patch."
   (let ((newpatch (make-instance 'sheet :name name :icon 127)))
     (set-icon-pos newpatch posi)
     newpatch))

(defmethod mkobjfromtype ((type (eql :omsh))) 'omNG-make-new-sheet)


(defmethod ws-load-more-element ((type (eql :omsh))  path name) 
  (let ((newobj (omNG-make-new-sheet name)))
    (setf (mypathname newobj) path)
    (setf (loaded? newobj) nil)
    newobj))

(omg-defclass sheet-icon-frame (patch-icon-frame) ())

(defmethod get-class-icon ((self sheet)) 'sheet-icon-frame)

(defmethod obj-file-type ((self sheet)) :OMSH)

(defmethod get-object-insp-name ((self sheet)) "sheet")

(defmethod save-all-persistants ((self sheet))
   "Save a patch at the end of the session."
   (unless (saved? self) (omng-save self)))

(defmethod obj-file-extension ((self sheet)) "she")


(defmethod OpenEditorframe ((self sheet))
  (declare (special *om-current-persistent*)) 
  (unless (loaded? self)
    ;(setf *loaading-stack* nil)
    (om-print (string+ "Loading..." (path2str (mypathname self))))
    (setf *om-current-persistent* nil)
    (om-with-cursor *om-wait-cursor* 
      (eval-non-text-file (mypathname self))
      (when *om-current-persistent*
        (setf (inside self) (inside *om-current-persistent*))
        (setf (params self) (params *om-current-persistent*))
        (setf (mus-patch self) (mus-patch *om-current-persistent*))
        (when (< (omversion *om-current-persistent*) *om-version*)
          (corrige-version self (omversion *om-current-persistent*))))
      ;(update-patches-pile)
      (setf (loaded? self) t)
      (setf *om-current-persistent* nil)))
  (or (editorframe self)
      (panel 
       (make-editor-window (get-editor-class self) self (if (and (mypathname self) (not (saved? self))) (string+ "^" (name self)) (name self)) self)))
)

(defmethod cons-patch-pairs ((self sheet))
  (let ((boxes (append (boxes (mus-patch self))
                       (loop for ev in (loop for tr in (inside self) append (objs tr))  collect ev))))
    (om-save-patch-sheet1 (mus-patch self) boxes)))

(defmethod om-save-patch-sheet1 ((self OMPatchAbs) boxes &optional (values? nil))
   "Generation of code to save 'self'."
   (let ((connectiones (mk-connection-list boxes))
         (theboxes (mapcar #'(lambda (box) (omNG-save box values?)) (boxes self))) pictlist)
     (setf pictlist (omng-save (pictu-list self)))
     `(om-load-patch-sheet ,(name self) ',theboxes ',connectiones ,*om-version* ,pictlist)))

(defvar *global-sheet* nil)

(defmethod set-patch-pairs ((self sheet) list)
  (let ((*global-sheet* self))
    (setf (mus-patch self) (eval list))
    (remake-references self)))

(defun om-load-patch-sheet (name boxes connections &optional (version nil) (pictlist nil))
  "This function is called when you load a saved Abstraction patch."
  (let ((newpatch (make-instance 'OMPatchAbs :name name :icon 210))
        (sheetboxes (loop for ev in (loop for tr in (inside *global-sheet*) append (objs tr))  collect ev)))
    (setf (boxes newpatch) nil)
    (mapc #'(lambda (box) (omNG-add-element newpatch (eval box))) boxes)
    (setf (boxes newpatch) (reverse (boxes newpatch)))
    (setf (saved? newpatch) connections)
    (remk-connections (append (boxes newpatch) sheetboxes) 
                      (loop for i in connections collect (load-connection i)))
    (setf (pictu-list newpatch) pictlist)
    (compile-patch newpatch)
    (when version
      (setf (omversion newpatch) version))
    newpatch))

(defmethod omNG-save ((self sheet) &optional (values? nil))
  "Save the patch <self> in the file <mypathname> if it is not null."
  (if (not (mypathname self))
    ;(dialog-message (str-check "Error: the file could not be found"))
    (call-next-method)
    (progn
      (unless (string-equal (pathname-type (mypathname self)) (obj-file-extension self))
        (delete-file-protection (mypathname self))
        (setf (mypathname self) (om-put-path-extension (mypathname self) (obj-file-extension self))))
      (setf *saving-patch* self)
      (setf *libs-to-load* nil)
      (delete-file-protection (mypathname self))
      (with-open-file (out (mypathname self) :direction :output 
                           :if-does-not-exist :create :if-exists :supersede) ;;;; :external-format :PATC)
        (write-header self out)
        (prin1 '(in-package :om) out)
        (let ((*package* (find-package :om))
              (patch-code (om-save self values?)))
          (prin1 `(load-lib-for ',(remove-duplicates *libs-to-load* :test 'string-equal)) out)
          (prin1 patch-code out))
        (om-set-mac-file-type out (obj-file-type self)))
      (om-set-file-format (mypathname self))
      (om-print (string+ (namestring (mypathname self)) " saved."))
      (setf (saved? self) t)
      (setf *saving-patch* nil)
      (setf *libs-to-load* nil)
      (when (editorframe self) (om-set-window-title (window (editorframe self)) (name self)))
      ;;;(print (string+ (namestring (mypathname self)) " enregistre"))
      t)))

(defmethod om-save ((self sheet) &optional (values? nil))
   (let* ((voices (mapcar #'(lambda (v) (omNG-save v values?)) (voices self)))
          (params (omng-save (params self)))
          (boxes (append (boxes (mus-patch self))
                         (loop for ev in (loop for tr in (inside self) append (objs tr))  collect ev)))
          (patch (om-save-patch-sheet1 (mus-patch self) boxes)))
     `(setf *om-current-persistent* (om-load-sheet ,(name self) ',voices ,params ,*om-version* ',patch))
     ))

(defun om-load-sheet (name voices params version patch)
   (let* ((newsheet (omNG-make-new-sheet name))
         (*global-sheet* newsheet))
     (setf (inside newsheet) (loop for v in voices collect (eval v)))
     (setf (params newsheet) params)
     (setf (mus-patch newsheet) (eval patch))
     (when version (setf (omversion newsheet) version))
     newsheet))


(defmethod omNG-connect ((source t) numout  (target t) numin lines &optional (col 0))
   (when (and (< numout (numouts source)) (nth numin (inputs target)))
     (connect-ctrl source (nth numin (inputs target)) numout)
     (when lines
       (setf (nth 2 (connected? (nth numin (inputs target)))) lines))
     (setf (nth 3 (connected? (nth numin (inputs target))))
           (if (null col) 0 col))))




(defmethod omNG-copy ((self sheet))
  (call-next-method))

(defmethod omNG-save-ws ((self sheet))
  (unless (saved? self)
    (if (or *save-apply-all* (om-y-or-n-dialog (string+ "Save modifications in " (name self) "?")))
      (omNG-save self nil)))
  (set-finder-comment (mypathname self) self))

(defmethod corrige-version ((self sheet) (number t)) t)



(defmethod drop-allow-p ((D&DHandler omdrag-drop) (dragged sheet) (target OMWorkSpace)) t)
(defmethod drop-allow-p ((D&DHandler omdrag-drop) (dragged sheet) (target OMFolder)) t)


;;;=====================================
;;; OBjet Sheet Box
;; --> BoxEditCall 

(defmethod copy-sheet-value ((self sheet))
  (let ((sheet (make-instance 'sheet 
                 :voices (loop for v in (voices self) collect (copy-container v))
                 :name (name self)
                 :icon (icon self))))
    (setf (params sheet) (copy-container (params self)))
    sheet))

;;; WS TO PATCH

(defmethod make-editor-from-obj ((self patchPanel) obj pos &optional name)
  (let* ((box (make-new-editorcall (class-of obj) pos 
                                   (or name (mk-unique-name self (name obj))))))
    (setf (value box) (clone obj))
    (omG-add-element self (make-frame-from-callobj box))))

(defmethod make-editor-from-obj ((self patchPanel) (obj sheet) pos &optional name)
  (let* ((nm (or name (mk-unique-name self (name obj))))
         (box (make-new-editorcall (class-of obj) pos nm)))
    (setf (value box) (copy-sheet-value obj))
    (omG-add-element self (make-frame-from-callobj box))))

(defmethod perform-drop ((D&DHandler omdrag-drop) (dragged sheet-icon-frame) 
                         (target patchPanel) position)
  (make-editor-from-obj  target (object dragged) position (name (object dragged))) 
  t)

(defmethod perform-drop ((D&DHandler omdrag-drop) (dragged sheet-icon-frame) 
                         (target icon-finder) position)
  nil)


;;; PATCH TO WS

(defmethod abs2sheet ((self sheet) name pos)
   (let ((newsheet (copy-sheet-value self)))
     (set-icon-pos newsheet (get-icon-pos self))
     (when name (setf (name newsheet) name))
     newsheet))

(defmethod perform-drop ((D&DHandler omdrag-drop) (dragged boxeditorframe) 
                         (target WorkSpacePanel) position)
  (box-to-ws dragged target (value (object dragged)) position))

(defmethod perform-drop ((D&DHandler omdrag-drop) (dragged boxeditorframe) 
                         (target FolderPanel) position)
  (box-to-ws dragged target (value (object dragged)) position))

(defmethod box-to-ws (box target obj position) nil)

(defmethod box-to-ws ((box boxeditorframe) target (obj sheet) position)
  (let* ((newsheet (abs2sheet obj (mk-unique-name target (name box)) position))
         (new-frame (make-icon-from-object newsheet (om-point-h position) (om-point-v position) 1 1)))
    (omg-add-element target new-frame)
    (omng-save newsheet)
    t))

(defmethod drop-allow-p ((D&DHandler omdrag-drop) (dragged OMBoxEditCall) (target omworkspace)) 
  (or (equal 'sheet (class-name (reference dragged)))
      (call-next-method)))

(defmethod drop-allow-p ((D&DHandler omdrag-drop) (dragged OMBoxEditCall) (target OMFolder)) 
  (or (equal 'sheet (class-name (reference dragged)))
      (call-next-method)))
