;OpenMusic
;
;Copyright (C) 1997, 1998, 1999, 2000 by IRCAM-Centre Georges Pompidou, Paris, France.
; 
;This program is free software; you can redistribute it and/or
;modify it under the terms of the GNU General Public License
;as published by the Free Software Foundation; either version 2
;of the License, or (at your option) any later version.
;
;See file LICENSE for further informations on licensing terms.
;
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License for more details.
;
;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
;
;Authors: Gerard Assayag and Augusto Agon

(in-package :om)
;=====================================================

(defmethod allowed-in-maq-p ((self score-element)) t)
(defmethod allowed-in-maq-p ((self voice)) t)
(defmethod allowed-in-maq-p ((self poly)) t)
(defmethod allowed-in-maq-p ((self measure)) t)
(defmethod allowed-in-maq-p ((self chord)) t)
(defmethod allowed-in-maq-p ((self note)) t)
(defmethod allowed-in-maq-p ((self MidiFile))  (good-val-p? self))
(defmethod allowed-in-maq-p ((self sound))  (good-val-p? self))

;=====================================================

(defmethod get-obj-dur ((self simple-container)) (real-dur self))
(defmethod get-obj-dur ((self MidiFile)) (extent self))
(defmethod get-obj-dur ((self note)) (dur self))
;(defmethod get-obj-dur ((self chord)) (real-dur self))

(defmethod get-obj-dur ((self sound)) (extent self))


;=====================================================

(defun micro-channel (midic)
  (+ 1 (/ (mod midic 100) 25)))


(defmethod real-dur ((self note)) 
  ;(round (* (dur self) (/ 60 (QTempo self) ))))
  (case (tie self)
    (begin (loop for obj = self then (next-tied-note obj)
                 while obj
                 sum (extent->ms obj)))
    (t (extent->ms self))))



(defmethod real-duration ((self note) time)
  (values time (+ time (dur self))))



(defmethod allow-strech-p ((self sound) (factor number)) nil)
(defmethod allow-strech-p ((self MidiFile) (factor number)) nil)

(defmethod allow-strech-p ((self sequence*) (factor number)) factor )




;(setf chord (mki 'chord :lmidic '(6000 6500 6700) :loffset '(500 -813 500)))
;
;(before-zero chord 0 0)
;(extent chord)
;(real-dur chord)