(in-package :om)

;============ GRACES NOTES

(defclass* grace-notes () 
  ((glist :initform '((6000)) :accessor glist :initarg :glist)
   (mus-color :initform *om-red-color* :accessor mus-color)
   (parent :initform nil :accessor parent)))


(defmethod! set-grace-notes ((self chord) chords)
  (setf (gnotes self) (make-instance 'grace-notes
                        :glist chords))
  (gnotes self))


;attention avec save and copy and make-instance in chords




;**************************************************************
; GRAPHIC
;**************************************************************

;------ADD/SUPPR
#|
(defmethod om-get-menu-context ((object grap-ryth-chord))
  (let ((rep (list (om-new-leafmenu "Tonalite"
                                    #'(lambda () 
                                        (set-obj-tonalite (reference object)))))))
    (when (tonalite (reference object))
      (setf rep (append rep (list (om-new-leafmenu "Suppr. Tonalite"
                                                   #'(lambda () 
                                                       (set-tonalite (reference object) nil)))))))
    (setf rep (append rep (list (om-new-leafmenu "Edit grace notes"
                                                 #'(lambda () 
                                                     (add-grace-notes (reference object) ))))))
    (when (gnotes (reference object))
      (setf rep (append rep (list (om-new-leafmenu "Suppr. grace notes"
                                                   #'(lambda () 
                                                       (delete-grace-notes (reference object) )))))))
    rep))
|#

(defmethod add-grace-notes ((self chord))
  (setf (gnotes self) (make-instance 'grace-notes
                        :glist '((7100 7400) (7100 7400) (7100 7400))
                        ;:glist '(  (6000))
                        ;:glist '(  (7300))
                        ))
  (gnotes self))

(defmethod delete-grace-notes ((self chord))
  (setf (gnotes self) nil))

;-----DRAW heads graces notes

(defvar *grace-factor* 4/3)
(setf *grace-factor* 5/3)

(defmethod draw-head-grace ((self t) x y zoom minx maxx miny maxy slot size linear?  staff chnote)
  (declare (ignore minx maxx miny maxy linear? grille-p))
  (let* ((new-size (round size *grace-factor*))
         (realrealpos (+ 1 x (* (/ new-size 4) (delta-head self)) (* zoom (- (x self) (* (/ new-size 4) (delta-head self))))))
         (realpos (round realrealpos))
         (altpos (if (alteration self) 
                   (round (- (+ realrealpos (* (- (alteration self) 1) (/ new-size 4))) (* (/ new-size 4) (delta-head self))))
                   realpos))
         (str (headchar self))
         (headsizex (get-name-size str (om-make-font *music-font* new-size)))
         (note (reference self))
         (note-color (get-mus-color note))
         (altstr (string (alt-char self)))  
         tie)
    (om-with-fg-color nil (if chnote (nth (chan (reference self)) *16-color-list*) note-color)
      (om-with-font (om-make-font *heads-font* new-size) 
                    (om-draw-string  realpos (+ y (y self))  str)) 
      (when (alteration self)
        (om-with-font (om-make-font *micron-font* new-size) 
                      (om-draw-string altpos (+ y (y self)) altstr)))
      
      (setf (rectangle self) (list altpos (+ y (- (y self) (round new-size 8)))
                                   (+ realpos (round new-size 3)) (+ y (round new-size 8) (y self)))))
    (draw-auxiliar-lines self x y  size realpos headsizex)))



;----------BUILD



(defmethod make-graces-from-list ((self grace-notes) top staffsys linespace scale sel pere grc)
  (let ((list (glist self)))
    (when list
      (if (= (length list) 1)
        (make-simple-grace self top staffsys linespace scale sel pere grc)
        (make-group-grace self top staffsys linespace scale sel pere grc)))))

;--------simple
(defclass s-grap-grace-notes (grap-grace-notes grap-ryth-chord) ())

(defmethod get-grace-width ((self s-grap-grace-notes) )
  (nth 2 (rectangle self)))


(defmethod make-simple-grace ((self grace-notes) top staffsys linespace scale sel pere grc)
  (let* ((list (glist self))
         (chord (make-instance 'chord :lmidic (car list)))
         (thenotes (sort (copy-list (inside chord)) '< :key 'midic))
         (onlyhead (head-1/4))
         (beams-num 1)
         (zigzag-list (make-alt-zig-zag chord scale))
         (note-head-list (make-chord-zig-zag chord scale))
         (new-grace (make-instance 's-grap-grace-notes
                      :reference chord
                      :parent self
                      :grc grc
                      :selected (member self sel :test 'equal)))
         (maxw 0))
    (setf (inside new-grace)
          (loop for item in thenotes
                for pos in note-head-list
                for i = 0 then (+ i 1)
                collect
                (let ((notegrap (make-graph-ryth-obj item  top staffsys linespace  scale sel new-grace nil nil))
                      (alt-char (get-alt-char item scale (armure staffsys)))
                      notew)
                  (setf (points notegrap) 0)
                  (setf (delta-head notegrap) (round pos *grace-factor*))
                  (setf (headchar notegrap) onlyhead)
                  (when alt-char
                    (setf (alt-char notegrap) alt-char))
                  (when (natural-alt-char notegrap)
                    (setf (alteration notegrap) (correct-alteration notegrap (pop zigzag-list))))
                  (setf notew (round (* 2 (max (* linespace pos)
                                               (* linespace (if (alteration notegrap) (* -1 (- (alteration notegrap) 1)) 0)))) *grace-factor*))
                  (setf (rectangle notegrap) (list 0 0 notew (round linespace)))
                  (setf (nth 0 (main-point notegrap)) (round (* linespace pos) *grace-factor*))
                  (setf maxw (max maxw notew))
                  notegrap)))
    (setf (beams-num new-grace) beams-num)
    (setf (stemdir new-grace) (chord-direction new-grace (midicenter staffsys)))
    (setf (stemhigh new-grace) (round (* 2.5 linespace) *grace-factor*))
    (setf (rectangle new-grace)  (list 0 0 maxw 0))
    new-grace))


;draw
(defmethod draw-grace-notes ((self s-grap-grace-notes) x y zoom minx maxx miny maxy slot size linear?  staff chnote)
  (om-with-fg-color nil (mus-color (reference self))
    (let* ((dir (stemdir self))
           (thenotes (copy-list (inside self))))
      (loop for item in thenotes do
            (draw-head-grace item x  y zoom minx maxx miny maxy slot size linear? staff chnote))
      ;(collect-rectangles self)
      ;(draw-rectangle  self staff size)
      (om-with-font (om-make-font *heads-font* (round size *grace-factor*))
                    (draw-chord-grace-stem self x y zoom (beams-num self) dir (round size *grace-factor*))))))

(defmethod draw-chord-grace-stem ((self grap-ryth-chord) x0 y0 zoom numbeams  dir size)
  (let* ((domaine (om+ y0 (get-min-max self)))
         (taille (round (max (+ (/ size 4) (* (- numbeams 1) (/ size 3))) (* size 7/8)))) 
         (yfin  (if (string-equal dir "up") 
                  (- (car domaine)  taille)
                  (+ (second domaine)  taille)))
         (ystart (if (string-equal dir "up") (second domaine) (car domaine)))
         (xpos (if (string-equal dir "up") 
                 (round (+  1 x0 (/ size 3.5) (* zoom (x self))))
                 (round (+  x0  (* zoom (x self)))))))
    (draw-stem-no-group  xpos (selected self)  ystart  yfin)
    (if  (string-equal dir "up")
      (progn
        (draw-beam-string  xpos (round (+ (+ yfin (* 1/4 size)) )) (beam-up) (selected self))
        (om-draw-char  xpos (round (+ (+ yfin (* 1/2 size)) )) (code-char 111) ))
      (progn
        (draw-beam-string  xpos (round  yfin ) (beam-dwn) (selected self))
        (om-draw-char  xpos (round (+ (+ yfin 0) (* 1/8 size))) (code-char 112) )))))

;-------group
(defclas g-grap-grace-notes (grap-grace-notes grap-group) ())

(defmethod get-grace-width ((self g-grap-grace-notes))
  (let ((rep 0))
    (loop for item in (inside self) do
          (setf rep (+ rep  (nth 2 (rectangle item)))))
    rep))

(defmethod make-group-grace ((self grace-notes) top staffsys linespace scale sel pere grc)
  (let* ((list (glist self))
         (chord-seq (make-instance 'chord-seq :lmidic list))
         new-group direstart)
    
    (setf new-group (make-instance 'g-grap-grace-notes
                      :grc grc
                      :reference self
                      :parent pere))
    
    (setf (numdenom new-group)  nil)
    
    (setf (inside new-group) (loop for item in (inside chord-seq) 
                                   for i = 0 then (+ i 1)
                                   collect
                                   (make-graph-ryth-obj  item  top staffsys linespace  scale sel new-group 1/8 )))
    
    
    (setf direstart (calcule-dir-et-start new-group (midicenter staffsys)))
    (set-dir-and-high-grace new-group (car direstart) linespace)
    new-group))

(defmethod set-dir-and-high-grace ((self grap-group) dir linespace)
   (setf (dirgroup self) dir)
   (loop for item in (inside self) do
         (set-dir-and-high-grace item dir linespace)))


(defmethod set-dir-and-high-grace ((self grap-ryth-chord) dir linespace)
   (setf (stemdir self)  dir)
   (setf (stemhigh self) (* 2 linespace) ))

;draw

(defmethod draw-grace-notes ((self g-grap-grace-notes) x y zoom minx maxx miny maxy slot size linear?  staff chnote)
  (loop for chord in (inside self) do
        (let* ((dir (stemdir chord))
               (thenotes (inside chord)))
          (loop for item in thenotes do
                (draw-head-grace item x y zoom minx maxx miny maxy slot size linear? staff chnote))
          (collect-rectangles chord)
          ))
  (collect-rectangles self)
  (let ((dire (dirgroup self)))
    (om-with-font (om-make-font *heads-font* (round size *grace-factor*))
                  (group-draw-stems self dire  x y (rectangle self)  zoom (round size *grace-factor*))
                  (draw-beams-note-in-group self dire x -1 (rectangle self)  zoom (round size *grace-factor*))
                  (if (string-equal dire "up")
                    (om-draw-char  (+ (car (rectangle self)) (round size 5)) (+ (second (rectangle self)) (round size 4)) (code-char 111) )
                    (om-draw-char  (- (third (rectangle self)) (round size 2.9)) (+ (fourth (rectangle self)) (round size 5)) (code-char 111) )))))


;=========AYAYAYAYAY
;m


(defmethod space-size ((self grap-ryth-chord)) 
  (+ (get-grace-width  (grap-grace-notes self)) 
     (loop for item in (inside self) maximize  (third (rectangle item))) ))

(defmethod collect-rectangles ((self grap-ryth-chord) )
  (let ((rect (loop for item in (inside self) 
                    maximize (fourth (rectangle item)) into y1
                    maximize (third (rectangle item)) into x1
                    minimize (first (rectangle item)) into x
                    minimize (second (rectangle item)) into y
                    finally (return (list x y x1 y1))))
        rect2)
    (when (grap-grace-notes self) 
      (setf rect2 (collect-rectangles (grap-grace-notes self))))
    
    (when rect2
      (setf (nth 0 rect) (min (nth 0 rect) (nth 0 rect2))
            (nth 1 rect) (min (nth 1 rect) (nth 1 rect2))
            (nth 2 rect) (max (nth 2 rect) (nth 2 rect2))
            (nth 3 rect) (max (nth 3 rect) (nth 3 rect2))))
    (if (string-equal (stemdir self) "up")
      (setf (rectangle self) (list (car rect) (- (second rect) (stemhigh self)) (third rect) (fourth rect) ))
      (setf (rectangle self) (list (car rect) (second rect) (third rect) (+ (fourth rect) (stemhigh self)) )))))


(defmethod set-graph-rectangles ((self grap-ryth-chord))
  (loop for item in (inside self) do (set-graph-rectangles item))
  (when (grap-grace-notes self)
    (set-graph-rectangles (grap-grace-notes self)))
  (collect-rectangles self))


;------------------------
(defmethod space-graces ((self grap-ryth-chord)  onseti  count size maxdur)
  (if (grap-grace-notes self)
    (do-space-graces self (grap-grace-notes self) onseti count size maxdur) 0))


(defmethod space-graces ((self t)  onseti  count size maxdur) 0)

(defmethod do-space-graces ((self grap-ryth-chord) (grace s-grap-grace-notes) onseti  count size maxdur)
  (let ((rep 0))
    (setf (main-point grace) (list (+ count  maxdur) (second (main-point grace))))
    (loop for item in (inside grace) do
          (setf (main-point item) (list (+ count (first (main-point item))  maxdur) (second (main-point item)))))
    (+ size (nth 2 (rectangle grace)))))

(defmethod do-space-graces ((self grap-ryth-chord) (grace g-grap-grace-notes) onseti  count size maxdur)
  (let ((rep 0))
    (loop for chord in (inside grace) do
          (setf (main-point chord) (list (+ count  maxdur rep ) (second (main-point chord))))
          (setf rep (+ rep (+ size (nth 2 (rectangle chord)))))
          (loop for item in (inside chord) do
                (setf (main-point item) (list (+ rep (round (+ count maxdur (round size 2) size (first (main-point item)))  *grace-factor*)) 
                                              (second (main-point item))))))
    (+ rep (round size  2))))


;;;;;SPACING

(defmethod space-girl ((obji+1 null) onseti+1 (obji grap-ryth-chord)  onseti  count size maxdur)
  (let ((gracew (space-graces obji  onseti  count (round size 2) maxdur)))
    (setf (main-point obji) (list (+ count  maxdur gracew) (second (main-point obji))))
    (loop for item in (inside obji) do
          (setf (main-point item) (list (+ count (first (main-point item))  maxdur gracew) (second (main-point item)))))
    (+ count  gracew size )))
 


(defmethod space-girl ((obji+1 t) (onseti+1 integer) (obji grap-ryth-chord) (onseti integer) count size maxdur) 
  (let ((gracew (space-graces obji  onseti  count (round size 2) maxdur)))
    (setf (main-point obji) (list (+ count  maxdur gracew) (second (main-point obji))))
   (loop for item in (inside obji) do
         (setf (main-point item) (list (+ count (first (main-point item)) maxdur gracew) (second (main-point item)))))
   (if (zerop (- onseti+1 onseti))
     (+ gracew count)
     (+ count (* maxdur 2) gracew (round (* size (ryhtm2pixels (- onseti+1 onseti)))) (round size 4)))))

;before a mesure
(defmethod space-girl ((obji+1 grap-measure) (onseti+1 integer) (obji grap-ryth-chord) (onseti integer) count size maxdur) 
  (let ((gracew (space-graces obji  onseti  count (round size 2) maxdur)))
    (setf (main-point obji) (list (+ count  maxdur gracew) (second (main-point obji))))
    (loop for item in (inside obji) do
          (setf (main-point item) (list (+ count (first (main-point item)) maxdur gracew) (second (main-point item))))
          )
    (if (zerop (- onseti+1 onseti))
      (+ count  gracew (round size 2)) 
      (+ count gracew (* maxdur 2)  (round (* size (ryhtm2pixels (- onseti+1 onseti)))) (round size 4)))))




