(in-package :om)


(defclass* OSCEvent (simple-score-element)
  ((host :accessor host :initarg :host :initform "127.0.0.1")
   (port :accessor port :initarg :port :initform 3000)
   (bundle :accessor bundle :initarg :bundle :initform '((nil)) )
   )
  (:icon 611))


(defmethod allowed-in-maq-p ((self OSCEvent))  t)
(defmethod get-obj-dur ((self OSCEvent)) 0)
(defmethod get-impulsion-pict ((self settings-ctrl)) *ctrl-impulsion-pict*)

(defmethod real-dur ((self OSCEvent)) (values 0 0))
(defmethod extent ((self OSCEvent)) 0)
   
(defmethod update-miniview ((self t) (value OSCEvent)) 
   (om-invalidate-view self t))

(defmethod draw-obj-in-rect ((self OSCEvent) x x1 y y1 edparams view)
   (om-with-focused-view view
     (om-draw-rect 0 0 (w view) (h view))
     (om-draw-string 10 20 "OSC Event")
     (om-draw-string 10 30 (string+ (host self) " - " (integer-to-string (port self))))
     (om-draw-string 10 40 (format nil "~s" (bundle self)))
))

(defmethod draw-mini-view  ((self t) (value OSCEvent)) 
   (draw-obj-in-rect value 0 (w self) 0  (h self) (view-get-ed-params self) self))


(defmethod* PrepareToPlay ((player t) (self OSCEvent) at &key approx port interval voice)
  (declare (ignore approx))
  (call-next-method)
  t)

(defmethod DoPlay ((self OSCEvent) start end)
  (call-next-method)
  (om-send-osc-bundle (port self) (host self) (bundle self)))

(defmethod DoStop ((self OSCEvent)) t)

(defmethod DoPause ((self OSCEvent)) t)

(defmethod DoContinue ((self OSCEvent)) t)




(defvar *oscpackage* (omNG-protect-object (omNG-make-new-package "OSC")))
(addPackage2Pack *oscpackage* *audiopackage*)
(AddClass2Pack '(OSCEvent) *oscpackage*)
(AddGenFun2Pack  '(osc-send osc-receive) *oscpackage*)