(in-package :om)

(defun equalrot (A B)
  (let (resultat)
    (setf resultat (loop for i from 1 to (length A) do 
                         (when (equal (om::rotate A i) B)
                           (return t))))
    resultat))

  (defmethod! n-scale ((l list))
  :initvals '((2 2 2 6) ) :indoc '("values" )
  :doc "It builds subset of the cyclic group Z/nZ starting from its interval structure. Notice that the period n is the sum of the elements of the interval structure" 
  :icon 420 
  (butlast (dx->x 0 l)))
  
  
  (defmethod! n-structure ((l list) (n integer))
  :initvals '((5 7 9) 12) :indoc '("values" "n")
  :doc "It builds the interval structure of a given subset of the cyclic group Z/nZ." 
  :icon 420 
  (let ((rep (x->dx l)))
    (append rep (list (- n (apply '+ rep))))))


;============================


(defun factorial (n)
  (if (zerop n) 1 (* n (factorial (- n 1))) ))

(defun binomial (m n)
  (/ (factorial m) (* (factorial n) (factorial (- m n)))))

(defun divisors (m)
  (loop for i from 1 to m
        when (zerop (mod m i)) collect i))

(defun euler (m)
  (if (= m 1) 1
      (length (loop for i from 1 to (- m 1)
            when (relativelyprimes  m i) collect i))))

(defmethod! card ((n integer) (k integer))
  :initvals '(12 6) :indoc '("Zn" "elments")
  :doc "Nombre de structures intervallaires ayant k elements a une transposition pres
Par exemple il y a 66 gammes de sept notes a l'intrieur du total chromatique a une transposition pres."
   :icon 420 
  (let ((pgcd (pgcd n k)))
    (* (/ 1 n) (loop for item in (divisors pgcd)
                     sum (* (binomial (/ n item) (/ k item)) (euler item))))))

;======================================

(defmethod! orbites ((n integer) (k integer) howmany)
  :initvals '(12 6 4) :indoc '("Zn" "elments" "how many answers")
  :doc "Ensembles de toutes structures intervallaires ayant k elements a une transposition pres." 
  :icon 420 
  (om-print "no conozco"))

;======================================

(defmethod! famille ((n integer) (familly string) (k integer) (howmany integer))
  :initvals '(12 "tac" 6 5) :indoc '("Zn" "familly" "number of elements" "howmany answers")
  :menuins '( ( 1 ( ("tac" "tac") ("tai" "tai") ("tic" "tic") ("ttl" "ttl")
                   ("tp" "tp") ("tid" "tid"))))
  :doc "a faire"
  :icon 420 
  (let ((rep (sfamille n (interne familly) k howmany)))
    (loop for item in rep collect (n-scale item)))) 


(defmethod sfamille ((n integer) (familly t) k howmany)
  (om-print "no conozco"))

(defmethod sfamille ((n integer) (familly (eql 'tac)) k howmany) 
  (om-print "no conozco"))

(defmethod sfamille ((n integer) (familly (eql 'tai)) k howmany)
  (om-print "no conozco") )

(defmethod sfamille ((n integer) (familly (eql 'tic)) k howmany) 
  (om-print "no conozco"))

(defmethod sfamille ((n integer) (familly (eql 'ttl)) k howmany) 
  (om-print "no conozco"))

(defmethod sfamille ((n integer) (familly (eql 'tp)) k howmany) 
  (om-print "no conozco"))

(defmethod sfamille ((n integer) (familly (eql 'tid)) k howmany) 
  (om-print "no conozco"))
