;OpenMusic
;
;Copyright (C) 1997, 1998, 1999, 2000 by IRCAM-Centre Georges Pompidou, Paris, France.
; 
;This program is free software; you can redistribute it and/or
;modify it under the terms of the GNU General Public License
;as published by the Free Software Foundation; either version 2
;of the License, or (at your option) any later version.
;
;See file LICENSE for further informations on licensing terms.
;
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License for more details.
;
;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
;
;Authors: Gerard Assayag and Augusto Agon

(in-package :om)


;(let ((path (make-pathname :directory (pathname-directory *load-pathname*))))
;  (setf (logical-pathname-translations "SoundProj")
;    (list (list "**;*.*" "cl:code;projects;6-AnalyseSynthese;**;"))))

(defvar *csound-orcs* "SoundProj:OMchroma;new-omchroma;classes;csoundfiles;orc;")

(defvar *asynth-files* nil)

(setf *asynth-files* 
  '(
    "tools;sound-tools"
    "tools;utils-from-chroma"
    "tools;snd-streams"
    ;"chroma;chroma"
    ;;;"Maquette;SynthMaquette"
    
    ))

 (eval-when (eval compile load)
  (mapc #'(lambda (filename) 
            (compile&load (namestring (make-local-path *load-pathname* filename)))) 
        *asynth-files*))


;======================
;SDIF
;======================
(defvar *sdif-lib-files* nil)

(setf *sdif-lib-files* '("sdif;sdif-struct"
			 "sdif;sdiffile"
			 "sdif;sdif-write"
			 "sdif;matrix"
			 "sdif;cseq2sdif"
                               ;;;"SoundProj:sdif;partiels"   ;; --> dans la librairie Repmus
			"sdif;sdifpack"    ; a decommenter
                               ))


(eval-when (eval compile load)
  (mapc #'(lambda (filename) 
            (compile&load (namestring (make-local-path *load-pathname* filename)))) 
        *sdif-lib-files*))
     
;======================
;CSOUND
;======================
(unless   *ml2-release*
  (defvar *csound-files* nil)

  (setf *csound-files* '( 
			 "csound;csound-preferences"
			 "csound;csound-synth"
			 ))

  (push :CSOUND *features*)

  (eval-when (eval compile load)
    (mapc #'(lambda (filename) 
	      (compile&load (namestring (make-local-path *load-pathname* filename)))) 
	  *csound-files*))

  (defvar *csound-package*  (omNG-protect-object (omNG-make-new-package "CSound")))
  
  (addPackage2Pack *csound-package* *audiopackage*)
  
  (AddGenFun2Pack '(CSound-Synth) *csound-package*))

;======================
;SVP
;======================
(unless   *ml2-release*
  (defvar *svp-files* nil)
  (setf *svp-files* '(
		      "svp;svp-preferences"
		      "svp;svp-processing"
		      "svp;svp-analyse"
		      ;;"SoundProj:SVP;synthesis"
		      ))
  
  (push :SVP *features*)

  (eval-when (eval compile load)
    (mapc #'(lambda (filename) 
	      (compile&load (namestring (make-local-path *load-pathname* filename)))) 
	  *svp-files*)))

;======================
;CHANT
;======================
(unless   *ml2-release*
  (compile&load (namestring (make-local-path *load-pathname* "chant;chant-synth"))))

;======================
;PREFERENCES
;======================

(compile&load (namestring (make-local-path *load-pathname* "tools;sound-preferences")))

;======================
;CHROMA
;======================
(unless   *ml2-release*
  (defvar *OMchroma-files* nil)
   
  (setf *OMchroma-files* (list

                      
                      ;CHROMA; KERNEL SYSTEM
                         ;SYS
                        "chroma;kernel;init-chroma"
                        "chroma;kernel;globals"
                        "chroma;kernel;utils-cr"
  
                        ;PLS
                        "chroma;kernel;pls;utils-pls"
                        "chroma;kernel;pls;all-purp"
                        "chroma;kernel;pls;type"
                        "chroma;kernel;pls;tbl"
                        "chroma;kernel;pls;fun"
                        "chroma;kernel;pls;ctl"
                        "chroma;kernel;pls;raw"
                        "chroma;kernel;pls;wt"
                        "chroma;kernel;pls;wt-frz"
                        
                        ;DG
                        "chroma;kernel;dg;df"
                        "chroma;kernel;dg;spectrum"
                        
                        ;VPS
                        "chroma;kernel;vps;globals-vps"
                        "chroma;kernel;vps;symbolic-pitch"
                        "chroma;kernel;vps;pitch-conversions"
                        "chroma;kernel;vps;utils-vps"
                        "chroma;kernel;vps;vps"
                        "chroma;kernel;vps;chord"
                        "chroma;kernel;vps;spectrum"
                        "chroma;kernel;vps;user-vps"
                        "chroma;kernel;vps;modif-vps"
                        "chroma;kernel;vps;modif-empty-vps"
                        "chroma;kernel;vps;match"
                        
                        ;MODELS
                        "chroma;kernel;models;analysis-data"
                        "chroma;kernel;models;f0-data"
                        "chroma;kernel;models;cseq-data"
                        "chroma;kernel;models;additive-data"
                        "chroma;kernel;models;formant-data"
                        "chroma;kernel;models;specenv-data"
                        "chroma;kernel;models;model"
                        "chroma;kernel;models;regions"
                        "chroma;kernel;models;f0-model"
                        "chroma;kernel;models;specenv-model"
                        "chroma;kernel;models;cseq-model"                        
                        "chroma;kernel;models;cseq-regions"
                        "chroma;kernel;models;partials-model"
                        "chroma;kernel;models;partials-regions"
                        "chroma;kernel;models;modif-models"
                        "chroma;kernel;models;modif-regions"
                        "chroma;kernel;models;user-model"
                        "chroma;kernel;models;utils-model"
  
                        ;CTL2
                        "chroma;kernel;ctl2;globals-ctl2"
                        "chroma;kernel;ctl2;ctl2001"
                        "chroma;kernel;ctl2;utils-ctl2001"


                        ;----------------------------------------
                      ;OMCHROMA; GRAPHICAL OBJECTS
                      ; - global sources
                        "chroma;omchroma;synthesize"
                        "chroma;omchroma;classes"
                        "chroma;omchroma;general-parsing"
                        
                     ; - Csound sources
                        "chroma;omchroma;csound;cs-utils"
                        "chroma;omchroma;csound;csound-evt"
                        "chroma;omchroma;csound;csound-tools"
                        "chroma;omchroma;csound;csound-parsing"
                         
                      ; - Chant
                        "chroma;omchroma;chant"

                        ;- user funs
                        "chroma;omchroma;user-funs;user-funs"
                        "chroma;omchroma;user-funs;methods"
                        
                        ;- omchroma classes
                        "chroma;omchroma;def-classes"

                        ;- new
                        "chroma;omchroma2;models"
                        "chroma;omchroma2;processing"
                        "chroma;omchroma2;controls"
                        "chroma;omchroma2;pack"
                        
                        
                       
                        ))

(eval-when (eval compile load)
    (mapc #'(lambda (filename) 
	      (compile&load (namestring (make-local-path *load-pathname* filename)))) 
	  *OMchroma-files*))
)