;=============================================================================
;		ADD1.ORC
; SIMPLE ADDITIVE SYNTHESIS (FROM ACCCI, 02_01_3.ORC) / MONO
; AMPLITUDE ENVELOPE WITH OSCILI
;=============================================================================

; Timbre:    gong
; Synthesis: additive same units (02)
;            basic instrument( 01)
; Source:    #420  Gong-like Sounds, Risset(1969)
; Coded:     jpg 8/93, modified ms 9/02

;-----------------------------------------------------------------------------

;	p1	= instrument number
;	p2	= action time [sec]
;	p3	= duration [sec]
;	p4	= maximum amplitude [linear, 0.0 -> 1.0]
;	p5	= frequency [Hz]
;	p6	= amplitude envelope [GEN number]

;-----------------------------------------------------------------------------
; COMPULSORY GEN FUNCTIONS :
;	f1	audio wave
;_____________________________________________________________________________


; GEN functions **********************************************************
; audio wave
f1  0   4097   9  1  1  0

; envelopes
f51  0   513   5  128 513 1



; score ******************************************************************
;  start  idur   iamp	 ifq	  iaenv

i1   0	   10	91		240			51         ; synchronous decay
i1   .     .    76		277      	.
i1   .     .    61		385      	.
i1   .     .    91		605		.
i1   .     .    31		340      	.
i1   .     .     .		670  	        .
i1   .     .     .		812   	        .


i1  11    10     91		240      	51         ; non-synchronous decay
i1   .     9.6   76		277      	.
i1   .     8.8   61		385      	.
i1   .     1.6   91		605      	.
i1   .     8.0   31		340      	.
i1   .     5.2    .		670         	.
i1   .     4.0    .		812         	.


i1  22    8.0    91		242.5  		51     ; different frequencies
i1   .    7.6    76		307.5  		.      ; non-synchronous decay
i1   .    6.8    31		340.0  		.
i1   .    4.8    61		384.0   	.
i1   .    3.6    31		521.0   	. 
i1   .    2.8    46		802.0   	. 

i1  31    10     91		240       	51		; 4 overlapping attacks
i1   .     9.6   76		277 		.       	; beats
i1   .     8.8   61		385      	.
i1   .     1.6   91		605      	.
i1   .     8.0   31		340      	.
i1   .     5.2    .		670         	.
i1   .     4.0    .		812         	.

i1 32.8    8.8   61		241.25		51
i1   .     8.4   46		262.25 		.
i1   .     4.0   76		357.5 		.
i1   .     5.2   31		302.5 		.
i1   .     4.4    .		315         	.
i1   .     7.6    .		385         	.
i1   .     6.4    .		482.5       	.

i1 33.2   11.6   91		242.5 		51
i1   .    10.8   76		307.5 		.
i1   .    10.4   31		340 		.
i1   .     6.4   61		384 		.
i1   .     4.8   31		512  		.
i1   .     4.4   46		820  		.

i1 38.8   13.6   46		240  		51
i1   .    12.8   38		277 		.
i1   .    12.0   46		385 		.
i1   .    8.4    15		605 		.
i1   .    3.20   31		340 		.
i1   .    6.40   15		670 		.
i1   .    4.40   15		812 		.

e
