;=============================================================================
;		FOG-1.ORC
; GRANULAR SYNTHESIS (NEW INSTRUMENT) / MONO
; AMPLITUDE ENVELOPE WITH OSCILI
;=============================================================================

; Timbre:    Granular synthesis with fog module, voice-like tones
; Synthesis: FOG (Forme d'Onde Granulaire)
;            OSCILI envelopes
; Coded:     ms 9/02

; NB1: this instrument works AT BEST with samples whose length is a power of 2
;      those which are shorter than the immediately superior power of 2 accepted
;		 by the GEN 1, will produce silence when looking up the unsued portion
;		  of the table

; NB2: the apparently arbitrary amplitude range (0-1000, rather than 0-1)
;         avoids Lisp printing small values with exponential notation

;-----------------------------------------------------------------------------

;	p1	= instrument number
;	p2	= action time [sec]
;	p3	= duration [sec]
;	p4	= maximum amplitude [linear, 0.0 -> 1000.0]
;	p5	= transposition factor [1 = no transposition]
;	p6	= speed [1 = original]
;	p7	= density of the grains [Hz]
;	p8	= audio file [GEN1 number]
;	p9	= amplitude envelope [GEN number]
;	p10	= rise time of the excitation envelope [sec]
;	p11	= duration of the excitation envelope [sec]
;	p12	= decay time of the excitation envelope [sec]

;-----------------------------------------------------------------------------
; COMPULSORY GEN FUNCTIONS
;	f101	audio file
;_____________________________________________________________________________

; audio file
f101  0  524288  1   "veena.aif"    0    0  0
; sigmoid rise/decay
f19 0  8192  19 .5 .5 270 .5

; amplitude envelope
f31 0 513 7 0.0  20 1  90 1  402 0.0  1 0.0

; score ******************************************************************

;  iatk idur   iamp	ixpf ispeed	idens ifun iaenv kris  kdur  kdec
i1  0    10     100	  2	  	0.5	  100	101	31	 0.01	0.1	0.05


e

