;=============================================================================
;		RAN-1.ORC
; RANDOM NUMBER GENERATION MODULATING THE AMPLITUDE OF AN OSCILLATOR
;    (FROM ACCCI, 02_41_1.ORC) / MONO
; AMPLITUDE ENVELOPE WITH LINEN, CONTROL OF AUDIO FUN FROM THE SCORE
;=============================================================================

; Timbre:       Noise spectra, with control of bandwidth and center freq
; Synthesis:    Random Number Generation
;               RANDI
;               LINEN envelope on RANDI ring modulates an oscillator
; Source:       Dodge(1985), p. 92
; Coded:        jpg 8/92, modified ms 9/02

; NB: the apparently arbitrary amplitude range (0-1000, rather than 0-1)
;         avoids Lisp printing small values with exponential notation
;-----------------------------------------------------------------------------

;	p1	= instrument number
;	p2	= action time [sec]
;	p3	= duration [sec]
;	p4	= maximum amplitude [linear, 0.0 -> 1000.0]
;	p5	= fundamental frequency [Hz]
;	p6	= attack time of the amplitude envelope [sec]
;	p7	= decay time of the amplitude envelope [sec]
;	p8	= spectral scaler for the audio frequency
;	p9	= % of jitter (low-frequency random frequency variation) [0-1]

;-----------------------------------------------------------------------------
; COMPULSORY GEN FUNCTIONS :
;	f1	audio wave
;_____________________________________________________________________________



; GEN functions **********************************************************
; AUDIO FUNCTIONS
f1  0  4097  10  1			; sinus
							; mainly odd partials (-> 13)
f2  0  4097  10  1  0 .3 0 .5 0 .2 .03 .1 .02 .05 .005 .02


; score ******************************************************************

; NB: control of pitched-ness in % can be added
;    idur  iamp	ifq	iran_fq iatk idec iaudiofun

i1  0  1	250	400	80	0.2	0.3	1
i1  2  1   	.     .	40   .  .  .
i1  4  1   	.     .	20   .  .  .

i1  6  1	250	400	50	0.2	0.3	2
i1  8  1   	.     .	25   .  .  .
i1 10  1   	.     .	10   .  .  .

e

