(in-package :om)

;;; modifie dans OM2CSound
;;; editsco


(defmethod! CSOUND-SYNTH ((sco pathname) (orc pathname) (out-name string))
  :icon 410
  (setf *flags* *csound-defflags*)
  (let* ((out (if out-name out-name "snd-out"))
         (tmpout (unique-pathname *om-tmpfiles-folder* out "tmp"))
         (outpath (unique-pathname *om-outfiles-folder* out "aiff"))
         (rescale -6) (resolution 16))
    (print "CSOUND SYNTHESIS...")
    
    (om-cmd-line (print (format nil "~s ~A ~s ~s -o ~s" 
                          (om-path2cmdpath *CSOUND-PATH*)
                          *flags*
                          (om-path2cmdpath orc)
                          (om-path2cmdpath sco)
                          (om-path2cmdpath (om-namestring tmpout))
                          ))
                 t)
    (if (probe-file *SVP-PATH*)
        (progn
          (print "SOUND RESCALE")
          (om-cmd-line (print (format nil "~s -S~S -norm ~D -Osa~D ~S" 
                                (om-path2cmdpath *SVP-PATH*)
                                (om-path2cmdpath (om-namestring tmpout)) 
                                (* -1 rescale) resolution
                                (om-path2cmdpath outpath))))
          (delete-intermediates (list tmpout)))
      (rename-file tmpout outpath))
             
    (om-namestring outpath)

    ))

(defmethod! CSOUND-SYNTH ((sco t) (orc t) (out-name string))
  :icon 410
  (csound-synth (pathname sco) (pathname orc) out-name))

