
(in-package :om)



;;;;=================================================
;;;;SND PREFERENCES MODULE  icon 221
;;;;=================================================


(defmethod put-preferences ((iconID (eql 221)))
  (let ((modulepref (get-pref-by-icon iconID)))
     (if (probe-file (first (defvals modulepref)))
       (setf *om-outfiles-folder* (first (defvals modulepref)))
       (push "output" *restore-defaults*))
     (if (probe-file (second (defvals modulepref)))
       (setf *om-tmpfiles-folder* (second (defvals modulepref)))
       (push "temp" *restore-defaults*))
     (if (probe-file (third (defvals modulepref)))
       (setf *om-infiles-folder* (third (defvals modulepref)))
       (push "input" *restore-defaults*))
     (when (nth 3 (defvals modulepref))
       (put-external-preferences 'csound (nth 3 (defvals modulepref))))
     (when (nth 4 (defvals modulepref))
       (put-external-preferences 'svp (nth 4 (defvals modulepref))))
     t))


;(defvals (get-pref-by-icon 221))

(defmethod save-external-prefs ((module t)) nil)
(defmethod put-external-preferences ((module t) listprefs) nil)
(defmethod get-external-def-vals ((module t)) nil)
(defmethod show-external-prefs-dialog ((module t) listprefs) nil)

(defmethod save-pref ((iconID (eql 221)) item)
   (list 221 `(list ,(om-save-pathname *om-outfiles-folder*)
                    ,(om-save-pathname *om-tmpfiles-folder*)
                    ,(om-save-pathname *om-infiles-folder*)
                    ,(save-external-prefs 'csound)  ;;; csound
                    ,(save-external-prefs 'svp)  ;;; svp
                    )))


(defmethod get-def-vals ((iconID (eql 221)))
  (list (check-snd-folder (make-pathname :device (pathname-device (mypathname *current-workspace*)) :directory (append (pathname-directory (mypathname *current-workspace*)) (list "out-files"))))
        (check-snd-folder (make-pathname :device (pathname-device (mypathname *current-workspace*)) :directory (append (pathname-directory (mypathname *current-workspace*)) (list "out-files"))))
        (check-snd-folder (make-pathname :device (pathname-device (mypathname *current-workspace*)) :directory (append (pathname-directory (mypathname *current-workspace*)) (list "in-files"))))
        (get-external-def-vals 'csound)   ;;; csound
        (get-external-def-vals 'svp)   ;;; svp
       
        ))
  

;;; appele juste apres la creation du workspace
(defun add-snd-prefs ()
 
  (pushr 
     (om-make-view 'pref-icon-view :iconID 221 :size (om-make-point 40 40) :position (om-make-point 5 195)
                   :defvals (get-def-vals 221)
                   )
     *pref-item-list*)
  )

(add-init-user-func 'add-snd-prefs)

;;;(defvals (get-pref-by-icon 221 *pref-item-list*))
;;; *om-outfiles-folder*




(defmethod make-new-pref-scroll ((win preferenceEditor) (num (eql 221)))
   (let ((thescroll (om-make-view 'PreferencePanel
                                  :size (om-make-point 500 500)
                                  :position (om-make-point 66 0)
                                  :scrollbars :v 
                                  :retain-scrollbars t))
         (modulepref (get-pref-by-icon num (object win)))
         outtxt tmptxt intxt)
     (om-add-subviews thescroll
                      (om-make-dialog-item 'om-static-text  (om-make-point 10 20) (om-make-point 80 15) "Output files :" :font *om-default-font2b*)
                      (setf outtxt (om-make-dialog-item 'om-static-text  (om-make-point 10 40) (om-make-point 200 45) (om-namestring *om-outfiles-folder*) ;;;(om-namestring (first (defvals modulepref)))
                                           :font *om-default-font1*))
                      (om-make-dialog-item 'om-button (om-make-point 250 30) (om-make-point 70 15) "Browse" 
                                           :di-action (om-dialog-item-act item
                                                                          (declare (ignore item))
                                                                          (let ((newfolder (om-choose-directory-dialog :directory (car (defvals modulepref)))))
                                                                            (when newfolder 
                                                                              (om-set-dialog-item-text outtxt (om-namestring newfolder))
                                                                              (setf (first (defvals modulepref)) newfolder)))))
                      
                      (om-make-dialog-item 'om-static-text  (om-make-point 10 80) (om-make-point 80 15) "Temp files :" :font *om-default-font2b*)
                      (setf tmptxt (om-make-dialog-item 'om-static-text  (om-make-point 10 100) (om-make-point 200 45) (om-namestring *om-tmpfiles-folder*) ;;;(om-namestring (second (defvals modulepref)))
                                           :font *om-default-font1*))
                      (om-make-dialog-item 'om-button (om-make-point 250 90) (om-make-point 70 15) "Browse" 
                                           :di-action (om-dialog-item-act item
                                                        (declare (ignore item))
                                                        (let ((newfolder (om-choose-directory-dialog :directory (second (defvals modulepref)))))
                                                          (when newfolder 
                                                            (om-set-dialog-item-text tmptxt (om-namestring newfolder))
                                                            (setf (second (defvals modulepref)) newfolder)))))

                      (om-make-dialog-item 'om-static-text  (om-make-point 10 140) (om-make-point 80 15) "Input files :" :font *om-default-font2b*)
                      (setf intxt (om-make-dialog-item 'om-static-text  (om-make-point 10 160) (om-make-point 200 45) (om-namestring *om-infiles-folder*) ;;;(om-namestring (third (defvals modulepref)))
                                           :font *om-default-font1*))
                      (om-make-dialog-item 'om-button (om-make-point 250 150) (om-make-point 70 15) "Browse" 
                                           :di-action (om-dialog-item-act item
                                                        (declare (ignore item))
                                                        (let ((newfolder (om-choose-directory-dialog :directory (third (defvals modulepref)))))
                                                          (when newfolder 
                                                            (om-set-dialog-item-text intxt (om-namestring newfolder))
                                                            (setf (third (defvals modulepref)) newfolder)))))
                      
                      )
     (when (member :CSOUND *features*)
       (om-add-subviews thescroll
                        (om-make-view  'button-icon
                                     :position (om-make-point 40 220) 
                                     :size (om-make-point 36 36)
                                     :action #'(lambda (item) (declare (ignore item))
                                                (let ((rep (show-external-prefs-dialog 'csound (nth 3 (defvals modulepref)))))
                                                  (when rep
                                                    (setf (nth 3 (defvals modulepref)) rep))))
                                      :iconid 606)
                        (om-make-dialog-item 'om-static-text  (om-make-point 35 260) (om-make-point 100 15) "Csound" :font *om-default-font2b*)))
     (when (member :SVP *features*)
       (om-add-subviews thescroll
                        (om-make-view 'button-icon
                                     :position (om-make-point 110 220) 
                                     :size (om-make-point 36 36)
                                     :action #'(lambda (item) (declare (ignore item))
                                                (let ((rep (show-external-prefs-dialog 'svp (nth 4 (defvals modulepref)))))
                                                  (when rep
                                                    (setf (nth 4 (defvals modulepref)) rep))))
                                      :iconid 950)
                        (om-make-dialog-item 'om-static-text  (om-make-point 105 260) (om-make-point 100 15) "SuperVP" :font *om-default-font2b*)))
     
     thescroll))







