(in-package :om)



(defclass! extra-tonality (extra-objet)
  ((tonality-str :initform "C" :initarg :tonality-str :accessor tonality-str)
   (deltax :initform 0  :accessor deltax)
   (deltay :initform 0  :accessor deltay)))


(defmethod get-slot-in-out-names ((self extra-tonality)) 
   (values '("self" "tonality-str")
           '(nil  "C")
           '("object or object list" "tonality" )
           '(nil (( 1 (("DO" "DO") 
                       ("SOL" "SOL")
                       ("RE" "RE")
                       ("LA" "LA") 
                       ("MI" "MI")
                       ("SI" "SI")
                       ("FA#" "FA#")
                       ("DO#" "DO#")
                       ("FA" "FA") 
                       ("SIb" "SIb")
                       ("MIb" "MIb")
                       ("LAb" "LAb") 
                       ("REb" "REb")
                       ("SOLb" "SOLb")
                       ("DOb" "DOb")
                       ("la" "la") 
                       ("mi" "mi")
                       ("si" "si")
                       ("fa#" "fa#") 
                       ("do#" "do#")
                       ("sol#" "sol#")
                       ("re#" "re#")
                       ("la#" "la#")
                       ("re" "re") 
                       ("sol" "sol")
                       ("do" "do")
                       ("fa" "fa") 
                       ("sib" "sib")
                       ("mib" "mib")
                       ("lab" "lab")))))))

(defmethod draw-obj-in-rect ((self  extra-tonality) x x1 y y1 edparams  view)
  (om-with-focused-view view
    (om-draw-string (round (- (+ x (/ (- x1 x) 2)) 5)) (round (+ y (/ (- y1 y) 2))) (tonality-str self))))


(defmethod make-graph-extra-obj ((self extra-tonality) gobj) nil)


(defmethod ton-extra-p ((self extra-tonality)) t)
(defmethod ton-extra-p ((self t)) nil)


(defmethod set-extra-in-list ((extra head-extra) (self t))
   (let ((newextra (clone extra)))
     (setf (object newextra) self)
     (setf (extra-obj-list self) (remove-if 'ton-extra-p (extra-obj-list self))) 
     (push newextra (extra-obj-list self))))

(defun get-extra-ton (self)
   (let ((head (find-if 'ton-extra-p (extra-obj-list self))))
     (when head
       (tonality-str head))))


(defmethod set-tonality ((self t) str)
  (let* ((tonality  (make-instance 'extra-tonality 
                      :tonality-str str)))
    (add-extra self tonality nil)))

;------------------------------------------

(defun get-armature-from-tonality (str)
  (cond
   ((or (string= str "DO") (string= str "la")) nil)
   ((or (string= str "SOL") (string= str "mi")) (list 'd '(8)))
   ((or (string= str "RE") (string= str "si")) (list 'd '(8 5)))
   ((or (string= str "LA") (string= str "fa#")) (list 'd '(8 5 9)))
   ((or (string= str "MI") (string= str "do#")) (list 'd '(8 5 9 6)))
   ((or (string= str "SI") (string= str "sol#")) (list 'd '(8 5 9 6 3)))
   ((or (string= str "FA#") (string= str "re#")) (list 'd '(8 5 9 6 3 7)))
   ((or (string= str "DO#") (string= str "la#")) (list 'd '(8 5 9 6 3 7 4)))
   
   ((or (string= str "FA") (string= str "re")) (list 'b '(4)))
   ((or (string= str "SIb") (string= str "sol")) (list 'b '(4 7)))
   ((or (string= str "MIb") (string= str "do")) (list 'b '(4 7 3)))
   ((or (string= str "LAb") (string= str "fa")) (list 'b '(4 7 3 6)))
   ((or (string= str "REb") (string= str "sib")) (list 'b '(4 7 3 6 2)))
   ((or (string= str "SOLb#") (string= str "mib")) (list 'b '(4 7 3 6 2 5)))
   ((or (string= str "DOb") (string= str "lab")) (list 'b '(4 7 3 6 2 5 1)))
   (t nil)))


(defun get-degrees-from-tonality (str)
  (cond
   ((string= str "DO") '(0 2 4 5 7 9 11))
   ((string= str "la") '(9 11 0 2 4 5 7))
   ((string= str "SOL") '(7 9 11 0 2 4 6))
   ((string= str "mi") '( 4 6 7 9 11 0 2))
   ((string= str "RE") '( 2 4 6 7 9 11 1))
   ((string= str "si") '(11 1 2 4 6 7 9))
   ((string= str "LA") '(9 11 1 2 4 6 8))
   ((string= str "fa#") '(6 8 9 11 1 2 4))
   ((string= str "MI") '(4 6 8 9 11 1 3))
   ((string= str "do#") '(1 3 4 6 8 9 11))
   ((string= str "SI") '(11 1 3 4 6 8 10))
   ((string= str "sol#") '(8 10 11 1 3 4 6))
   ((string= str "FA#") '(6 8 10 11 1 3 5))
   ((string= str "re#") '(3 5 6 8 10 11 1))
   ((string= str "DO#") '(1 3 5 6 8 10 0))
   ((string= str "la#") '(10 0 1 3 5 6 8))
   ((string= str "FA") '(5 7 9 10 0 2 4))
   ((string= str "re") '(2 4 5 7 9 10 0))
   ((string= str "SIb") '(10 0 2 3 5 7 9))
   ((string= str "sol") '(7 9 10 0 2 3 5 ))
   ((string= str "MIb") '(3 5 7 8 10 0 2))
   ((string= str "do") '( 0 2 3 5 7 8 10))
   ((string= str "LAb") '( 8 10 0 1 3 5 7))
   ((string= str "fa") '( 5 7 8 10 0 1 3))
   ((string= str "REb") '( 1 3 5 6 8 10 0))
   ((string= str "sib") '( 10 0 1 3 5 6 8 ))
   ((string= str "SOLb#") '( 6 8 10 11 1 3 5))
   ((string= str "mib") '( 3 5 6 8 10 11 1))
   ((string= str "DOb") '(11 1 3 4 6 8 10))
   ((string= str "lab") '(8 10 11 1 3 4 6))
   (t nil)))


(defun get-scale-from-tonality (str)
  (cond
   ((or (string= str "DO") (string= str "la")) *0#-scale*,)
   ((or (string= str "SOL") (string= str "mi")) *1#-scale*)
   ((or (string= str "RE") (string= str "si")) *2#-scale*)
   ((or (string= str "LA") (string= str "fa#")) *3#-scale*)
   ((or (string= str "MI") (string= str "do#")) *4#-scale*)
   ((or (string= str "SI") (string= str "sol#")) *5#-scale*)
   ((or (string= str "FA#") (string= str "re#")) *6#-scale*)
   ((or (string= str "DO#") (string= str "la#")) *7#-scale*)
   
   ((or (string= str "FA") (string= str "re")) *1b-scale*)
   ((or (string= str "SIb") (string= str "sol")) *2b-scale*)
   ((or (string= str "MIb") (string= str "do")) *3b-scale*)
   ((or (string= str "LAb") (string= str "fa")) *4b-scale*)
   ((or (string= str "REb") (string= str "sib")) *5b-scale*)
   ((or (string= str "SOLb#") (string= str "mib")) *6b-scale*)
   ((or (string= str "DOb") (string= str "lab")) *7b-scale*)
   (t nil)))


;=========
;;; redefinition
;;;(defmethod initialize-instance :after ((self scoreEditor) &rest l)
;;;   (declare (ignore l))
;;;   (let* ((size (get-edit-param self 'fontsize))
;;;           (staff (correct-staff self (get-edit-param self 'staff)))
;;;           (mode (get-edit-param self 'mode))
;;;           (obj-mode (get-edit-param self 'obj-mode))
;;;           (zoom (get-edit-param self 'zoom))
;;;           (palette-mode (get-edit-param self 'palette-mode))
;;;           (noteaschan (get-edit-param self 'notechancolor?))
;;;           (stemp (get-edit-param self 'show-stems))
;;;           (approx (get-edit-param self 'approx))
;;;           (ed-view (om-make-view  (get-score-class-panel self) 
;;;                                                  :position (om-make-point 0 0) 
;;;                                                  :font (om-make-font *music-font* size)
;;;                                                  :field-size (om-make-point  32767 32767)
;;;                                                  :owner self
;;;                                                  ;;;:size (om-make-point (- (w self) 15) (- (h self) 40))
;;;                                                  :size (om-make-point (w self) (- (h self) 25))
;;;                                                  :staff-tone approx
;;;                                                  :noteaschan? noteaschan
;;;                                                  :staff-sys (get-staff-system staff)
;;;                                                  :staff-zoom zoom
;;;                                                  :staff-mode mode
;;;                                                  :def-prefer (correct-page-par self (get-edit-param self 'cmnpref))
;;;                                                  :staff-size size))
;;;           (controls (om-make-view  (get-score-class-ctrls self) 
;;;                                                  :position (om-make-point 0 (- (h self) 25)) 
;;;                                                  :size (om-make-point (w self) 25)
;;;                                                  :staff (string  (car (list! staff)))
;;;                                                  :owner self
;;;                                                  :zoom zoom
;;;                                                  :mode mode
;;;                                                  :font-size (format nil "~D" size)
;;;                                                  :tone (format () "~D"  (/ 1 approx)))))
;;;     (om-set-field-size ed-view (om-make-point 10000 20000))  
;;;     (setf (show-stems ed-view) stemp)
;;;     (setf (ctr-view self) controls)
;;;     (setf (panel self) ed-view)
;;;     (set-editor-tonality  (panel self))      ;;; ici..
;;;     (setf (palette-mode ed-view) palette-mode)
;;;     (setf (obj-mode ed-view) (nth obj-mode (object-order ed-view)))
;;;     (init-draw self)
;;;     (init-boxes-in-score ed-view)
;;;     )
;;;   )




;;; redefinition
;;;(defvar *cur-arm* nil)
;;;(defclass OMSystem ()
;;;   ((staff-list :initform nil :initarg :staff-list :accessor staff-list)
;;;    (deltax :initform 2 :initarg :deltax :accessor deltax)
;;;    (sysname :initform nil :initarg :sysname :accessor sysname)
;;;    (armure :initform nil :initarg :armure :accessor armure)
;;;    (top-in-midi :initform 120  :initarg :top :accessor top-in-midi)))
;;;
;;;;;; redefinition
;;;(defmethod draw-system ((self OMSystem) x  xsize fontsize deltay selected &optional showtempo name)
;;;  (om-with-fg-color nil (if selected *select-color* *system-color*)
;;;    (let ((*cur-arm* (armure self))
;;;          y0 y1)
;;;      (loop for staff in (staff-list self) do
;;;            (let ((y (draw-staff  staff x  (top-in-midi self) xsize fontsize deltay (unless y0 showtempo) (unless y0 name))))
;;;              (unless y0 (setf y0 (first y)))
;;;              (setf y1 (second y))))
;;;      (list y0 y1))))
;;;
;;;
;;;;;; redefinition
;;;(defmethod draw-staff ((self OMStaff) x top xsize fontsize deltay &optional stempo name)
;;;   (let* ((linespace (/ fontsize (- (numlines self) 1)))
;;;          (mytop (line2pixel (posy self) top linespace)))
;;;     (draw-tempo 4 stempo (+ x 15)  (- (+  deltay mytop) (round fontsize 2))  fontsize name)
;;;     (loop for i from 0 to (- (numlines self) 1) do
;;;           (om-draw-line x (+  deltay (* i (round linespace)) mytop)
;;;                      (+ x xsize) (+  deltay (* i (round linespace)) mytop)))
;;;     (draw-key (key-obj self) (+ x 15) 
;;;               (+ deltay (* (- (numlines self) (keyline (key-obj self))) linespace) mytop) linespace)
;;;     (when *cur-arm*
;;;       (let ((char (first *cur-arm*))
;;;             (thelist (second *cur-arm*))
;;;             (deltak (if (equal #\? (key (key-obj self))) 10 8)))
;;;         (setf char (if (equal char 'b) (bemol) (diese)))
;;;         (loop for k in thelist
;;;               for i = 0 then (+ i 1) do
;;;               (om-draw-char (+ x (* i linespace) 15 fontsize) (round (+  deltay (* (* -1 (- k deltak)) (/ linespace 2)) mytop))
;;;                            char))))
;;;     (list (+  deltay  mytop)
;;;           (round (+  deltay (* (- (numlines self) 1) linespace) mytop)))))
;;;
;;;
;;;
;;;(defmethod set-armure ((self OMSystem) obj)
;;;  (when (get-extra-ton obj)
;;;   (setf (armure self)  (get-armature-from-tonality (get-extra-ton obj)))))
;;;
;;;
;;;(defmethod set-editor-tonality ((self scorePanel))
;;;  (when (staff-sys self)
;;;    (set-armure (staff-sys self) (object (om-view-container self)))))
;;;
;;;
;;;(defmethod get-approx-scale ((self scorePanel)) 
;;;  (cond
;;;   ((armure (staff-sys self)) (get-scale-from-tonality (get-extra-ton (object (om-view-container self)))))
;;;   (t (get-current-scale (staff-tone self)))))



(setf *7#-scale* 
  (make-instance 'scale 
    :alteration-list
    (list  (beca) nil (beca) nil (beca) nil nil (beca) nil (beca) (beca) nil)
    :lines-list
    (list  0 0 1 1 2 2 3 4 4 5 6 6)
    :approx-factor 100))

(setf *6#-scale* 
  (make-instance 'scale 
    :alteration-list
    (list  nil nil (beca) nil (beca) nil nil (beca) nil (beca) nil nil)
    :lines-list
    (list  7 0 1 1 2 2 3 4 4 5 5 6)
    :approx-factor 100))

(setf *5#-scale* 
  (make-instance 'scale 
    :alteration-list
    (list  (beca) nil (beca) nil nil (beca) nil (beca) nil (beca) nil nil)
    :lines-list
    (list  0 0 1 1 2 3 3 4 4 5 5 6)
    :approx-factor 100))

(setf *4#-scale* 
  (make-instance 'scale 
    :alteration-list
    (list  (beca) nil (beca) nil nil (beca) nil (beca) nil (beca) nil nil)
    :lines-list
    (list  0 0 1 1 2 3 3 4 4 5 5 6)
    :approx-factor 100))

(setf *3#-scale* 
  (make-instance 'scale 
    :alteration-list
    (list  (beca) nil (beca) nil (beca) nil nil (beca) nil (beca) (beca) nil)
    :lines-list
    (list  0 0 1 1 2 2 3 4 4 5 6 6)
    :approx-factor 100))

(setf *2#-scale* 
  (make-instance 'scale 
    :alteration-list
    (list  nil nil (beca) nil (beca) nil nil (beca) nil (beca) nil nil)
    :lines-list
    (list  7 0 1 1 2 2 3 4 4 5 5 6)
    :approx-factor 100))

(setf *1#-scale* 
  (make-instance 'scale 
    :alteration-list
    (list  (beca) nil (beca) nil nil (beca) nil (beca) nil (beca) nil nil)
    :lines-list
    (list  0 0 1 1 2 3 3 4 4 5 5 6)
    :approx-factor 100))

(setf *0#-scale* 
  (make-instance 'scale 
    :alteration-list
    (list  (beca) nil (beca) nil nil (beca) nil (beca) nil (beca) nil nil)
    :lines-list
    (list  0 0 1 1 2 3 3 4 4 5 5 6)
    :approx-factor 100))


(setf *7b-scale* 
  (make-instance 'scale 
    :alteration-list
    (list  (beca) nil (beca) nil (beca) nil nil (beca) nil (beca) (beca) nil)
    :lines-list
    (list  0 0 1 1 2 2 3 4 4 5 6 6)
    :approx-factor 100))

(setf *6b-scale* 
  (make-instance 'scale 
    :alteration-list
    (list  nil nil (beca) nil (beca) nil nil (beca) nil (beca) nil nil)
    :lines-list
    (list  7 0 1 1 2 2 3 4 4 5 5 6)
    :approx-factor 100))

(setf *5b-scale* 
  (make-instance 'scale 
    :alteration-list
    (list  (beca) nil (beca) nil nil (beca) nil (beca) nil (beca) nil nil)
    :lines-list
    (list  0 0 1 1 2 3 3 4 4 5 5 6)
    :approx-factor 100))

(setf *4b-scale* 
  (make-instance 'scale 
    :alteration-list
    (list  (beca) nil (beca) nil nil (beca) nil (beca) nil (beca) nil nil)
    :lines-list
    (list  0 0 1 1 2 3 3 4 4 5 5 6)
    :approx-factor 100))

(setf *3b-scale* 
  (make-instance 'scale 
    :alteration-list
    (list  (beca) nil (beca) nil (beca) nil nil (beca) nil (beca) (beca) nil)
    :lines-list
    (list  0 0 1 1 2 2 3 4 4 5 6 6)
    :approx-factor 100))

(setf *2b-scale* 
  (make-instance 'scale 
    :alteration-list
    (list  nil nil (beca) nil (beca) nil nil (beca) nil (beca) nil nil)
    :lines-list
    (list  7 0 1 1 2 2 3 4 4 5 5 6)
    :approx-factor 100))

(setf *1b-scale* 
  (make-instance 'scale 
    :alteration-list
    (list  (beca) nil (beca) nil nil (beca) nil (beca) nil (beca) nil nil)
    :lines-list
    (list  0 0 1 1 2 3 3 4 4 5 5 6)
    :approx-factor 100))

;;;(setf *current-1/2-scale*  *2-tone-chromatic-scale*)
;;;
;;;
;;;(defmethod give-alteration  ((self scale) midic)
;;;  (let* ((vlength (length (lines-list self)))
;;;         (int-cents (mod midic 1200))
;;;         (index (round (/ int-cents (approx-factor self) )))
;;;         (up-octave (truncate (/ index (length (lines-list self))))))
;;;    (setq index (mod index (length (lines-list self))))
;;;    (if (and (= (approx-factor self) 25) (= index (1- vlength))) (incf up-octave))
;;;    (list (nth index  (lines-list self)) (nth  index (alteration-list self)) up-octave)))

;=================



;==================
(defun get-degree (pitch tonality)
  (let ((pos (position pitch (get-degrees-from-tonality tonality) )))
    (when pos
      (+ pos 1))))

;(get-degrees-from-tonality "re")
;(get-degree 1 "re")


(defun get-pitch (degree tonality)
  (nth (- degree 1) (get-degrees-from-tonality tonality))
)

;(get-pitch 3 "re")

(defmethod om-transposition  ((self simple-container) source target)
  (let ((copy (clone self)))
    (transpose-ton copy source target)
    copy))

(defmethod om-transposition  ((self container) source target)
  (let ((copy (clone self)))
    (loop for item in (inside copy) do
          (transpose-ton item source target))
    copy))


(defmethod transpose-ton ((self container) source target)
  (loop for item in (inside self) do
        (transpose-ton item source target)))

(defmethod transpose-ton ((self simple-container) source target)
  self)

(defmethod transpose-ton ((self note) source target)
  (let* ((pitch-class (mod (round (approx-m (midic self) 2) 100) 12))
         (base (- (approx-m (midic self) 2) (* pitch-class 100)))
          (degree (get-degree pitch-class source))
          pitch)
    (if degree
        (progn 
           (setf pitch (get-pitch degree target))
             (when (< pitch degree ) (setf pitch (+ pitch 12)))
           (setf (midic self) (+ base (* pitch 100))))
      (progn
         (setf pitch-class (mod (round (approx-m (- (midic self) 100) 2) 100) 12))
         (setf base (- (approx-m (- (midic self) 100) 2) (* pitch-class 100)))
         (setf degree (get-degree pitch-class source))
         (setf (midic self) (+ base (* (+ 1 (get-pitch degree target)) 100)))
         ))))
  