

;--- contructing big lists when bigger than 300 elts (list ...) won't work

(in-package :om)


(eval-when (:compile-toplevel :load-toplevel :execute) 
  (export '(BigList) :om))

(defun ReduceList (list-last elt)
  (nconc list-last (cons  (eval elt) nil))
  (rest list-last))

(defun BList (elts)
  (let ((head (cons nil nil)))
    (reduce #'ReduceList elts :initial-value head )
    (rest head)))

(defmacro BigList (&rest elts)
  `(BList ',elts))

;----------------------------------------------------
;; define a package "dangerous" where 'list is redefined

(in-package :cl-user)

(defpackage :dangerous
  (:use)
  (:export  list)
  (:nicknames :da))

(in-package :da)

(cl:defmacro list (cl:&rest rest) `(om:BigList ,. rest))

(cl:in-package :cl-user)


;----------------------------------------------------
;; macro with-list-redefined : evaluate its body with standard list function
;; replaced by the macro BigList

(in-package :om)


;; this macro forces :om package to read list as a symbol in the :da package
;; instead of using the :cl package 'list, then restores the initial state of :om
;; evalue its body, then 


(defmacro with-list-redefined (&body body)
  `(let ((result))
     (handler-case
         (progn 
           (cl:shadowing-import '(da:list) :om)
           ;; do what you have to do
           (Format *stdout* "List function redefined as : ~S ~%" (symbol-package (intern "LIST" :om)))
           (setf result (progn ,. body))
           ;(unintern 'list :om)
           )
       (error (any)  (format *stdout* "AN ERROR HAPPENED :  ~S ~%" any) ))
     (unintern 'da:list :om)
     (Format *stdout* "List function redefined as : ~S ~%" (symbol-package (intern "LIST" :om)))
     result))

(defmacro with-open-oracle-file (params &rest body)
  `(with-open-file , params
    (with-list-redefined ,. body)))
